// Language Level Converter line number map: dj*->java. Entries: 27
//     1->6         2->7         3->8         4->9         5->10        6->11        7->12        8->13   
//     9->14       10->45       11->46       12->47       13->48       14->49       15->80       16->81   
//    17->82       18->83       19->84       20->85       21->86       22->87       23->88       24->89   
//    25->90       26->91       27->92   
/** IntList ::= EmptyIntList | ConsIntList(int, IntList). */
abstract class IntList { 
  /** Sorts this IntList into ascending (non-descending) order. */
  public abstract IntList sort();
  /** Adds the int n to the front of this IntList. */
  public IntList cons(final int n) { return new ConsIntList(n, this); }
  /** Inserts n in proper order in this, assuming this is sorted in ascending order. */
  public abstract IntList insert(final int n);

  /** This method is automatically generated by the Language Level Converter. */
  public IntList() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntList cast = ((IntList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class EmptyIntList extends IntList { 
  public IntList sort() { return this; }
  public IntList insert(final int n) { return cons(n); }

  /** This method is automatically generated by the Language Level Converter. */
  public EmptyIntList() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      EmptyIntList cast = ((EmptyIntList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class ConsIntList extends IntList {
  /** The first element of this IntList. */
  private final int first;
  /** The remaining elements of this IntList. */
  private final IntList rest;
  
  public IntList sort() { return rest.sort().insert(first); }
  public IntList insert(final int n) {
    if (n <= first) return cons(n);
    else return rest.insert(n).cons(first);
  }

  /** This method is automatically generated by the Language Level Converter. */
  public ConsIntList(int first, IntList rest) {
    super();
    this.first = first;
    this.rest = rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int first() {
    return first;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public IntList rest() {
    return rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        first() + ", " + 
        rest() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ConsIntList cast = ((ConsIntList) o);
      return (first() == cast.first()) && 
          (rest() != null && rest().equals(cast.rest()));
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        first() ^ 
        (rest() == null ? 0 : rest().hashCode());
  }
}
