import junit.framework.TestCase;

/** The JUnit test case class for IntList. */
public class IntListTest extends TestCase {

  public final static IntList E = EmptyIntList.ONLY;
  public final static IntList l1 = E.cons(17);                                      // '(17)
  public final static IntList l2 = l1.cons(5);                                      // '(5 17)
  public final static IntList l3 = E.cons(5);                                       // '(5)
  public final static IntList l4 = l3.cons(5);                                      // '(5 5)
  public final static IntList l5 = l3.cons(17);                                     // '(17 5)
  public final static IntList l6 = l5.cons(-5).cons(100).cons(50);                  // '(50 100 -5 17 5)
  public final static IntList l7 = E.cons(100).cons(50).cons(17).cons(5).cons(-5);  // '(-5 5 17 50 100)
  
  /** Tests the UpSort insert method. */
  public void testInsert() {
    assertEquals("empty insert test", l1, UpSorter.ONLY.insert(E, 17));
    assertEquals("pre insert test", l2, UpSorter.ONLY.insert(l1, 5));
    assertEquals("post insert test", l2, UpSorter.ONLY.insert(l3, 17));
    assertEquals("equals insert test", l4, UpSorter.ONLY.insert(l3, 5));
  }
  /** Tests the the UpSort Sorter. */
  public void testUpSort() {
    assertEquals("Empty list", E, E.applySort(UpSorter.ONLY));
    assertEquals("one elt test", l1, l1.applySort(UpSorter.ONLY));
    assertEquals("two elts in order test", l2, l2.applySort(UpSorter.ONLY));
    assertEquals("two elts out of order test", l2, l5.applySort(UpSorter.ONLY));
    assertEquals("two equal elts test", l4, l4.applySort(UpSorter.ONLY));
    
    
  }
  

  /** This method is automatically generated by the Language Level Converter. */
  public IntListTest() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntListTest cast = ((IntListTest) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}
