// Language Level Converter line number map: dj*->java. Entries: 43
//     1->8         2->9         3->10        4->11        5->12        6->13        7->14        8->15   
//     9->16       10->17       11->18       12->19       13->20       14->21       15->22       16->23   
//    17->24       18->25       19->26       20->27       21->28       22->29       23->30       24->31   
//    25->32       26->33       27->34       28->35       29->36       30->37       31->38       32->39   
//    33->40       34->41       35->42       36->43       37->44       38->45       39->46       40->47   
//    41->48       42->79       43->80   
import junit.framework.TestCase;

/** Test case class for the IntList composite classes with insert, sort, and merge. */

public class IntListTest extends TestCase {

  public final static IntList E = EmptyIntList.ONLY;
  public final static IntList l1 = E.cons(17);                                      // '(17)
  public final static IntList l2 = l1.cons(5);                                      // '(5 17)
  public final static IntList l3 = E.cons(5);                                       // '(5)
  public final static IntList l4 = l3.cons(5);                                      // '(5 5)
  public final static IntList l5 = l3.cons(17);                                     // '(17 5)
  public final static IntList l6 = l5.cons(-5).cons(100).cons(50);                  // '(50 100 -5 17 5)
  public final static IntList l7 = E.cons(100).cons(50).cons(17).cons(5).cons(-5);  // '(-5 5 17 50 100)
  public final static IntList l8 = E.cons(20).cons(0);                              // '(0 20)
  public final static IntList l9 = E.cons(100).cons(50).cons(20).cons(17).cons(5).cons(0).cons(-5); // '(-5 0 5 17 20 50 100)
  
  /** Tests the insert method. */
  public void testInsert() {
    assertEquals("empty insert test", l1, E.accept(new InsertVisitor(17)));
    assertEquals("pre insert test", l2, l1.accept(new InsertVisitor(5)));
    assertEquals("post insert test", l2, l3.accept(new InsertVisitor(17)));
    assertEquals("equals insert test", l4, l3.accept(new InsertVisitor(5)));
  }
  /** Tests the Insertion) sort method. */
  public void testSort() {
    assertEquals("empty sort test", E, E.accept(SortVisitor.ONLY));
    assertEquals("one elt test", l1, l1.accept(SortVisitor.ONLY));
    assertEquals("two elts in order test", l2, l2.accept(SortVisitor.ONLY));
    assertEquals("two elts out of order test", l2, l5.accept(SortVisitor.ONLY));
    assertEquals("two equal elts test", l4, l4.accept(SortVisitor.ONLY));
  }
  
  /** Tests the InsertVisitor operation. */
  public void testInsertVisitor() {
    assertEquals("empty insert test", l1, E.accept(new InsertVisitor(17)));
    assertEquals("pre insert test", l2, l1.accept(new InsertVisitor(5)));
    assertEquals("post insert test", l2, l3.accept(new InsertVisitor(17)));
    assertEquals("equals insert test", l4, l3.accept(new InsertVisitor(5)));
  }

  /** This method is automatically generated by the Language Level Converter. */
  public IntListTest() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntListTest cast = ((IntListTest) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}


