// Language Level Converter line number map: dj*->java. Entries: 31
//     1->6         2->7         3->8         4->9         5->10        6->11        7->12        8->13   
//     9->14       10->15       11->16       12->17       13->18       14->19       15->20       16->21   
//    17->22       18->23       19->24       20->25       21->26       22->27       23->28       24->29   
//    25->30       26->31       27->32       28->33       29->34       30->35       31->36   
import junit.framework.TestCase;

/** A JUnit test case class for the ComparableList composte classes. */

public class BoxedComparableListTest extends TestCase {
  /** Tests the insert method. */
  public final static ComparableList e = EmptyComparableList.ONLY;
  public final static ComparableList l1 = e.cons(new Integer(17));                                               // '(17)
  public final static ComparableList l2 = l1.cons(new Integer(5));                                               // '(5 17)
  public final static ComparableList l3 = e.cons(new Integer(5));                                                // '(5)
  public final static ComparableList l4 = l3.cons(new Integer(5));                                               // '(5 5)
  public final static ComparableList l5 = l3.cons(new Integer(17));                                              // '(17 5)
  public final static ComparableList l6 = l5.cons(new Integer(-5)).cons(new Integer(100)).cons(new Integer(50)); // '(50 100 -5 17 5)
  public final static ComparableList l7 = 
    e.cons(new Integer(100)).cons(new Integer(50)).cons(new Integer(17)).cons(new Integer(5)).cons(new Integer(-5));  // '(-5 5 17 50 100)
  
  public void testInsert() {
    assertEquals("empty insert test", l1, e.insert(new Integer(17)));
    assertEquals("pre insert test", l2, l1.insert(new Integer(5)));
    assertEquals("post insert test", l2, l3.insert(new Integer(17)));
    assertEquals("equals insert test", l4, l3.insert(new Integer(5)));
  }
  
  public void testSort() {
    assertEquals("empty sort test", e, e.sort());
    assertEquals("one elt test", l1, l1.sort());
    assertEquals("two elts in order test", l2, l2.sort());
    assertEquals("two elts out of order test", l2, l5.sort());
    assertEquals("two equal elts test", l4, l4.sort());
  }

  /** This method is automatically generated by the Language Level Converter. */
  public BoxedComparableListTest() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      BoxedComparableListTest cast = ((BoxedComparableListTest) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}
