import junit.framework.TestCase;

/** Test case class for BinSearch. */
public class OrderedArrayListTest extends TestCase {
  
  /** Tests insert. */
  public void testInsert() {
    OrderedArrayList<Integer> al = new OrderedArrayList<Integer>();
    assertEquals("empty al", "[]", al.toString());
    assertEquals("find 0", -1, al.find(0));
    assertEquals("find 15", -1, al.find(15));
    assertEquals("loopFind 0", -1, al.loopFind(0));
    assertEquals("loopFind 15", -1, al.loopFind(15));
    
    al.insert(5);
    assertEquals("al is [5]", "[5]", al.toString());
    assertEquals("find 5", 0, al.find(5));
    assertEquals("find 0", -1, al.find(0));
    assertEquals("find 15", -1, al.find(15));
    assertEquals("loopFind 5", 0, al.loopFind(5));
    assertEquals("loopFind 0", -1, al.loopFind(0));
    assertEquals("loopFind 15", -1, al.loopFind(15));
    
    al.insert(12);
    assertEquals("al is [5, 12]", "[5, 12]", al.toString());
    assertEquals("find 5", 0, al.find(5));
    assertEquals("find 12", 1, al.find(12));
    assertEquals("find 0", -1, al.find(0));
    assertEquals("find 15", -1, al.find(15));
    assertEquals("loopFind 5", 0, al.loopFind(5));
    assertEquals("loopFind 12", 1, al.loopFind(12));
    assertEquals("loopFind 0", -1, al.loopFind(0));
    assertEquals("loopFind 15", -1, al.loopFind(15));
    
    al.insert(4);
    assertEquals("al is [4, 5, 12]", "[4, 5, 12]", al.toString());
    assertEquals("find 4", 0, al.find(4));
    assertEquals("find 5", 1, al.find(5));
    assertEquals("find 12", 2, al.find(12));
    assertEquals("find 0", -1, al.find(0));
    assertEquals("find 15", -1, al.find(15));
    assertEquals("loopFind 4", 0, al.loopFind(4));
    assertEquals("loopFind 5", 1, al.loopFind(5));
    assertEquals("loopFind 12", 2, al.loopFind(12));
    assertEquals("loopFind 0", -1, al.loopFind(0));
    assertEquals("loopFind 15", -1, al.loopFind(15));
    // insert a duplicate element
    al.insert(4);
    assertEquals("al is [4, 4, 5, 12]", "[4, 4, 5, 12]", al.toString());
    assertTrue("find 4", al.find(4) >= 0 && al.find(4) <= 1);
    assertEquals("find 5", 2, al.find(5));
    assertEquals("find 12", 3, al.find(12));
    assertEquals("find 0", -1, al.find(0));
    assertEquals("find 15", -1, al.find(15));
    assertTrue("loopFind 4", al.loopFind(4) >= 0 && al.loopFind(4) <= 1);
    assertEquals("loopFind 5", 2, al.loopFind(5));
    assertEquals("loopFind 12", 3, al.loopFind(12));
    assertEquals("loopFind 0", -1, al.loopFind(0));
    assertEquals("loopFind 15", -1, al.loopFind(15));
  }
}
