// Language Level Converter line number map: dj*->java. Entries: 71
//     1->11        2->12        3->13        4->14        5->15        6->16        7->17        8->18   
//     9->19       10->20       11->21       12->22       13->23       14->24       15->25       16->26   
//    17->27       18->28       19->29       20->60       21->61       22->62       23->63       24->64   
//    25->65       26->66       27->67       28->68       29->69       30->70       31->71       32->72   
//    33->98       34->99       35->100      36->101      37->102      38->103      39->104      40->105  
//    41->106      42->107      43->108      44->109      45->110      46->111      47->112      48->113  
//    49->114      50->115      51->116      52->117      53->118      54->166      55->167      56->168  
//    57->169      58->170      59->171      60->172      61->173      62->174      63->213      64->214  
//    65->215      66->216      67->217      68->218      69->219      70->220      71->221  
/** Composite representation of IntList ::= EmptyIntList | ConsIntList(int, IntList) with visitor interface. */
interface IntListVisitor {
  public Object forEmptyIntList(final EmptyIntList host);
  public Object forConsIntList(final ConsIntList host);
}

abstract class IntList {
  public abstract Object accept(final IntListVisitor v);
  /** Sorts this IntList into ascending (non-descending) order. */
  public abstract IntList sort();
  /** Adds the int n to the front of this IntList. */
  public IntList cons(final int n) { return new ConsIntList(n, this); }
  /** Inserts n in proper order in this IntList, assuming this is sorted in ascending order. */
  public abstract IntList insert(final int n);
  /** Merges other with this IntList assuming both are sored in ascending (non-descending) order. */
  public abstract IntList merge(final IntList other);
  /** Merges other with this IntList assuming both are sored in ascending (non-descending) order, other is non-empty. */
  public abstract IntList mergeHelp(final ConsIntList other);

  /** This method is automatically generated by the Language Level Converter. */
  public IntList() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntList cast = ((IntList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class EmptyIntList extends IntList { 
  /** Field containing the only (singleton) EmptyIntList. */
  public final static EmptyIntList ONLY = new EmptyIntList();
  /** Constructor used to create ONLY (this). */
  private EmptyIntList() { }

  public Object accept(final IntListVisitor v) { return v.forEmptyIntList(this); }
  public IntList sort() { return this; }
  public IntList insert(final int n) { return cons(n); }
  public IntList merge(final IntList other) { return other; }
  public IntList mergeHelp(final ConsIntList other) { return other; }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      EmptyIntList cast = ((EmptyIntList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class ConsIntList extends IntList {
  /** The first element of this. */
  private final int first;
  /** The remaining elements of this. */
  private final IntList rest;
  
  public Object accept(final IntListVisitor v) { return v.forConsIntList(this); }
  public IntList sort() { return rest.sort().insert(first); }
  public IntList insert(final int n) {
    if (n <= first) return cons(n);
    else return rest.insert(n).cons(first);
  }
  public IntList merge(final IntList other) {
    if (other.equals(EmptyIntList.ONLY)) return this;
    else return other.mergeHelp(this); }
  public IntList mergeHelp(final ConsIntList other) {
    if (first <= other.first()) return rest.mergeHelp(other).cons(first);
    else return other.rest().merge(this).cons(other.first());
  }

  /** This method is automatically generated by the Language Level Converter. */
  public ConsIntList(int first, IntList rest) {
    super();
    this.first = first;
    this.rest = rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int first() {
    return first;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public IntList rest() {
    return rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        first() + ", " + 
        rest() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ConsIntList cast = ((ConsIntList) o);
      return (first() == cast.first()) && 
          (rest() != null && rest().equals(cast.rest()));
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        first() ^ 
        (rest() == null ? 0 : rest().hashCode());
  }
}

class InsertVisitor implements IntListVisitor {
  private final int elt;
  public IntList forEmptyIntList(final EmptyIntList host) { return host.cons(elt); }
  public IntList forConsIntList(final ConsIntList host) {
    if (elt <= host.first()) return host.cons(elt);
    return ((IntList)(host.rest().accept(this))).cons(host.first());
  }                      

  /** This method is automatically generated by the Language Level Converter. */
  public InsertVisitor(int elt) {
    super();
    this.elt = elt;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int elt() {
    return elt;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        elt() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      InsertVisitor cast = ((InsertVisitor) o);
      return (elt() == cast.elt());
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        elt();
  }
}
 
class MaxVisitor implements IntListVisitor {
  public final static IntListVisitor ONLY = new MaxVisitor();
  private MaxVisitor() { }
  public Integer forEmptyIntList(final EmptyIntList host) { 
    throw new IllegalArgumentException("max cannot be applied to the EmptyIntList"); 
  }
  public Integer forConsIntList(final ConsIntList host) { return Math.max(host.first(), (Integer)(host.rest().accept(this))); }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      MaxVisitor cast = ((MaxVisitor) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}
