// Language Level Converter line number map: dj*->java. Entries: 32
//     1->6         2->7         3->8         4->9         5->10        6->11        7->12        8->13   
//     9->14       10->15       11->16       12->47       13->48       14->49       15->50       16->51   
//    17->52       18->53       19->54       20->55       21->56       22->82       23->83       24->84   
//    25->85       26->86       27->87       28->88       29->89       30->90       31->91       32->139  
/* ObjectList ::= EmptyObjectList | ConsObjectList where ConsObjectList includes an Object and an ObjectList. */
abstract class ObjectList { 
  /** Adds the element n to the front of this ObjectList. */
  public ObjectList cons(final Object n) { return new ConsObjectList(n, this); }
   
  /** Returns a String representation of this ObjectList in Scheme format: (e1 ... en) . */
  public abstract String listString();
  /** Returns s String containing the elements of this ObjectList, where each element is preceded by ' '.  Hence,
    * (e1 e2... en) generates " e1 e2 ... en" */ 
  public abstract String listStringHelp();

  /** This method is automatically generated by the Language Level Converter. */
  public ObjectList() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ObjectList cast = ((ObjectList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class EmptyObjectList extends ObjectList {
  /** Field containing the only (singleton) EmptyObjectList. */
  public final static EmptyObjectList ONLY = new EmptyObjectList();
  /** Private constructor used to construct a singleton. */
  private EmptyObjectList() { }
  
  public String listString() { return "()"; }
  public String listStringHelp() { return ""; }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      EmptyObjectList cast = ((EmptyObjectList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class ConsObjectList extends ObjectList {
  /** The first element of this ObjectList. */
  private final Object first;
  /** The remaining elements of this ObjectList. */
  private final ObjectList rest;
  
  public String listString() { return "(" + first + rest.listStringHelp() + ")"; }
  public String listStringHelp() { return " " + first + rest.listStringHelp(); }

  /** This method is automatically generated by the Language Level Converter. */
  public ConsObjectList(java.lang.Object first, ObjectList rest) {
    super();
    this.first = first;
    this.rest = rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.Object first() {
    return first;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public ObjectList rest() {
    return rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        first() + ", " + 
        rest() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ConsObjectList cast = ((ConsObjectList) o);
      return (first() != null && first().equals(cast.first())) && 
          (rest() != null && rest().equals(cast.rest()));
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        (first() == null ? 0 : first().hashCode()) ^ 
        (rest() == null ? 0 : rest().hashCode());
  }
} 

