;; The first three lines of this file were inserted by DrScheme. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname Y) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
(define CBN-Y 
  (lambda (f)
    (local [(define core (lambda (x) (f (x x))))]
      (core core))))


; Let F-lambda be the functional 
; (lambda (f) (lambda (n) body))
; corresponding to the recursive definition (define (f x) body)

; In CBN, 
; (CBN-Y F-lambda) =>
; (F-lambda ((lambda (x) (F-lambda (x x))) (lambda (x) (F-lambda (x x)))))) =
; (F-lambda (CBN-Y F-lambda)) =>
; (lambda (n) body)[f <- (CBN-Y F-lambda)] which is what we want        

; In CBV, 
; (CBN-Y F-lambda) =>
; (F-lambda ((lambda (x) (F-lambda (x x))) (lambda (x) (F-lambda (x x)))))) =
; (F-lambda (CBN-Y F-lambda)) =>
; (F-lambda (F-lambda (CBN-Y F-lambda))) =
; (F-lambda (F-lambda (F-lambda (CBN-Y F-lambda)))) =
; ...

; for any unary function f, (lambda (x) (f x)) = f; this equation is called eta-conversion
; if F-lambda corresponds to a unary function definition, (CBN-Y F-lambda) = (lambda (x) ((CBN-Y F-lambda) x))
; In CBV,
; (F-lambda (lambda (x) ((CBN-Y F-lambda) x))) =>
; (lambda (n) body)[f <- (CBN-Y F-lambda)] which works for the base case input for n but fails in recursive calls

; We need a variant of Y (for each arity) which always wraps embedded occurrences of (Y F-lambda) in (lambda (z) ...) when (Y F-lambda) is expanded
; Call this variant CBV-Yk (where k is the arity of the recursively defined function)
; We obtain this variant by eta-converting the body "core" as follows:
(define CBV-Y1
  (lambda (f)
    (local [(define core (lambda (x) (lambda (z) ((f (x x)) z))))]
            (core core)))) 
(define FACT (lambda (f) (lambda (n) (if (zero? n) 1 (* n (f (sub1 n)))))))

((CBV-Y1 FACT) 6)