;; The first three lines of this file were inserted by DrScheme. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname new12) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
;; first-line: listOf(symbol) => listOf(symbol)
;; Purpose: (first-line l) returns the prefix of l ending in the first 'newline or the end of the stream
;; Examples:
(check-expect (first-line empty) empty)
(check-expect (first-line '(newline)) '(newline))
(check-expect (first-line '(a)) '(a))
(check-expect (first-line '(a newline)) '(a newline))
(check-expect (first-line '(a newline b)) '(a newline))

;; Template Instantiation
#|
(define (first-line s)
  (cond [(empty? s) ...]
        [(cons? s) ... (first-line (rest s)) ...  ]))
|#
(define (first-line s)
  (cond [(empty? s) empty]
        [(cons? s) 
         (if (equal? (first s) 'newline)
             (list 'newline)
             (cons (first s)(first-line (rest s))))]))       

;; rest-lines: listOf(symbol) => listOf(symbol)
;; Purpose: (rest-lines l) returns the suffix of l following the first 'newline or the end of the stream

;; Examples
(check-expect (rest-lines empty) empty)
(check-expect (rest-lines '(newline)) empty)
(check-expect (rest-lines '(a)) empty)
(check-expect (rest-lines '(a newline)) empty)
(check-expect (rest-lines '(a newline b)) '(b))

#|
(define (rest-lines s)
  (cond [(empty? s) ... ]
        [(cons? s) ...(rest-lines (rest s)) ...  ]))
|#
(define (rest-lines s)
  (cond [(empty? s) empty]
        [(cons? s) 
         (if (equal? (first s) 'newline)
             (rest s)
             (rest-lines (rest s)))])) 

;; parse: (listOf symbol) -> (listOf (listOf symbol))
;; (parse s) returns the list of lines (symbol sequences ending in 'newline or end of stream) in s
;; Examples
(check-expect (parse empty) empty)
(check-expect (parse '(newline)) '((newline)))
(check-expect (parse '(a)) '((a)))
(check-expect (parse '(a newline)) '((a newline)))
(check-expect (parse '(a newline b)) '((a newline) (b)))

(define (parse s)
  (cond [(empty? s) empty]
        [(cons? s) 
         (cons (first-line s) (parse (rest-lines s)))]))
